
#include <rsp.h>
#include "mbi.h"

		.text	0x04001000

#ifndef FASTLIGHT3D

#include "gdmem.h"
#include "gfx_regs.h"

		.text
#endif /* FASTLIGHT3D */
	
	####################################################################
	#
	# Newton-Raphson routine for the reciprocal approximation:
	#
	#	r2 = r * (2 - r * x)
	#
	# Does one pass of Newton's iteration.
	#
	# Does the *2 to S15.16 first.
	#
	# Uses registers:
	#
.name	xi,	$v29	# original x
.name	xf,	$v28
.name	ri,	$v27	# approximation of 1/x	(also holds iterated answer)
.name	rf,	$v26
.name	r2i, 	$v25	# intermediate value
.name	r2f, 	$v24
.name	vtmpi, 	$v23	# constant 2.0
.name	vtmpf, 	$v22
	
		.ent	NewtonDiv
	
		# NewtonDiv does the divide too, then the Newtons.
		# use of element 3h favors the transform code.
		#
	NewtonDiv:	
			vrcph	ri[3], xi[3]
			vrcpl	rf[3], xf[3]
			vrcph	ri[3], xi[7]
			vrcpl	rf[7], xf[7]
			vrcph	ri[7], vconst[0]
#ifdef NONEWTONTBL	/* Delay の間に処理する */
			vxor	vtmpf, vconst, vconst
#endif	
			vmudn	rf, rf, vconst[2]
			vmadh	ri, ri, vconst[2]
			vmadn	rf, vconst, vconst[0]
	Newtons:	
#ifdef NONEWTONTBL
			vadd	vtmpi, vtmpf, vconst[2]
#else
			lqv	vtmpi[0], VNEWT_OFFSET(zero)
 			vxor	vtmpf, vconst, vconst
#endif
			vmudl	r2f, rf, xf		#  R*X
			vmadm	r2f, ri, xf
			vmadn	r2f, rf, xi
			vmadh	r2i, ri, xi
			vsubc	r2f, vtmpf, r2f		#  2 - (R*X)
			vsub	r2i, vtmpi, r2i
			vmudl	vtmpf, rf, r2f		#  R * (2-R*X)
			vmadm	vtmpi, ri, r2f
			vmadn	rf, rf, r2i
			vmadh	ri, ri, r2i
			jr	return

			nop
#ifndef FASTLIGHT3D
			nop
			nop
			nop
			nop
			nop
			nop
#endif /* FASTLIGHT3D */
	
		.end	NewtonDiv
	
.unname xi
.unname xf
.unname ri
.unname rf
.unname r2i
.unname r2f
.unname vtmpi
.unname vtmpf
	#
	####################################################################
	
