/*************************************************************************
 *                                                                       *
 *               Copyright (C) 1994, Silicon Graphics, Inc.              *
 *                                                                       *
 *  These coded instructions, statements, and computer programs  contain *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and *
 *  are protected by Federal copyright  law.  They  may not be disclosed *
 *  to  third  parties  or copied or duplicated in any form, in whole or *
 *  in part, without the prior written consent of Silicon Graphics, Inc. *
 *                                                                       *
 ************************************************************************/
	
/* afilter.s */

.name	dm_in_out,	$23
.name	count,		$22
.name	scale,		$21
.name	coef_index,	$20
.name	dma_size,	$3
.name	state_addr,	$2
.name	dmem_addr,	$1

.name	idata0,	 	$v31
.name 	odata0,		$v30
.name	odataf,		$v29
.name	col1,		$v28
.name	col2,		$v27
.name	col3,		$v26
.name	col4,		$v25
.name	col5,		$v24
.name	col6,		$v23
.name	col7,		$v22
.name	col8,		$v21
.name	vtmp0,		$v20
.name	vtmp1,		$v19
.name	vtmp2,		$v18

case_A_POLEF:
.name	tmp,	$19

	srl	tmp, aud1, 24
	addi	coef_index, zero, RSP_ADPCMTABLE_OFFSET
				vxor	col8, col8, col8
	beq	tmp, zero, buff_swap
	addi	dm_in_out, zero, AL_BUFFER_TEMP_0
	addi	dm_in_out, zero, AL_BUFFER_TEMP_1

buff_swap:
	lqv	col1[0], 16(coef_index)
				vxor	col7, col7, col7
	mtc2	aud0, vtmp2[10]
				vxor	col6, col6, col6
	sll	aud0, aud0, 2
				vxor	col5, col5, col5
	mtc2	aud0, vtmp0[0]
				vxor	col4, col4, col4
	sll	state_addr, aud1, 8
				vxor	col3, col3, col3
	srl	state_addr, state_addr, 8
				vxor	col2, col2, col2
	addi	state_addr, state_addr, 0
	addi	dma_size, zero, POLEF_STATE_SIZE
	addi	tmp, zero, 0x4
	mtc2	tmp, vtmp2[0]
	addi	count, zero, AL_ALL_COUNTER
				vmudm	vtmp0, col1, vtmp0[0]
	srl	tmp, aud0, 18
	andi	tmp, tmp, A_INIT
	bgtz	tmp, polef_no_load
	sqv	vtmp0[0], 16(coef_index)

/*	addi	dmem_addr, scrbase, AL_POLEFILTER_TABLE_SIZE */
	addi	dmem_addr, scrbase, 0

	mfc0	tmp, SP_RESERVED
filterDMAreadwait:
	bne	tmp, $0, filterDMAreadwait
	mfc0	tmp, SP_RESERVED

	mfc0	tmp, DMA_FULL
filterDRFull1:
	bne	tmp, $0, filterDRFull1
	mfc0	tmp, DMA_FULL

	mtc0	dmem_addr, DMA_CACHE
	mtc0	state_addr, DMA_DRAM
	mtc0	dma_size, DMA_READ_LENGTH

	addi	coef_index, coef_index,-2
	lrv	col2[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col3[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col4[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col5[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col6[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col7[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col8[0], 32(coef_index)

	mfc0	$5, DMA_BUSY
polefwait1:	
	bne	$5, zero, polefwait1
	mfc0	$5, DMA_BUSY

	mtc0	$0, SP_RESERVED
	j	polef_after_load
	ldv	odata0[8], 0(dmem_addr)

polef_no_load:
	addi	coef_index, coef_index,-2
				vxor	odata0, odata0, odata0
	lrv	col2[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col3[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col4[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col5[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col6[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col7[0], 32(coef_index)
	addi	coef_index, coef_index,-2
	lrv	col8[0], 32(coef_index)

polef_after_load:
	lqv	idata0[0], 0(dm_in_out)

.unname	tmp

polefloop:
					vmudh	vtmp0, col1, odata0[7]
					vmadh	vtmp0, col2, idata0[0]
	addi	count, count, -16
					vmadh	vtmp0, col3, idata0[1]
					vmadh	vtmp0, col4, idata0[2]
	sqv	odata0[0], -16(dm_in_out)
					vmadh	vtmp0, col5, idata0[3]
					vmadh	odata0, col6, idata0[4]
					vmadh	vtmp0, col7, idata0[5]
					vmadh	vtmp0, col8, idata0[6]
					vmadh	vtmp0, idata0, vtmp2[5]
	lqv	idata0[0], 16(dm_in_out)
					vsaw	odataf, vtmp1, odata0[1]
					vsaw	odata0, vtmp1, odata0[0]
					vmudn	vtmp0, odataf, vtmp2[0]
					vmadh	odata0, odata0, vtmp2[0]
	bgtz	count, polefloop
	addi	dm_in_out, dm_in_out, 16

	addi	dmem_addr, dm_in_out, -8
	jal	DMAwrite
	sqv	odata0[0], -16(dm_in_out)

	addi	dlcount, dlcount, -8

	mfc0	$5, DMA_BUSY
polefwait2:	
	bne	$5, zero, polefwait2
	mfc0	$5, DMA_BUSY

	j	AudDone
	mtc0	$0, SP_RESERVED

.unname	dm_in_out
.unname	count
.unname	coef_index
.unname scale
.unname	dma_size
.unname state_addr
.unname dmem_addr

.unname	idata0
.unname odata0
.unname	odataf
.unname	col1
.unname	col2
.unname	col3
.unname	col4
.unname	col5
.unname	col6
.unname	col7
.unname	col8
.unname	vtmp0
.unname	vtmp1
.unname	vtmp2
